<script>
import Vue from 'vue';
import { UseLiteVimeo, UseLocalizedVideoSubtitles } from '~/mixins';
//
export default Vue.extend({
  name: 'ContributeVideo',
  mixins: [UseLiteVimeo, UseLocalizedVideoSubtitles],
  props: {
    data: {
      type: Object,
      required: true,
    },
  },
  computed: {
    frameSize() {
      return this.data.size || 'md';
    },
  },
});
</script>

<template>
  <div class="container">
    <div
      class="videoCard"
      :class="{ displace_left: data.displace_left }"
      :data-aos="data.aos_animation"
      :data-aos-duration="data.aos_duration"
    >
      <div class="videoCard__toggle">
        <SlpTypography
          v-if="data.header"
          tag="h2"
          variant="heading2"
          class="video_header"
        >
          {{ data.header }}
        </SlpTypography>
        <lite-vimeo
          :videoid="getVimeoVideoId(createVideoSource(data.video_url))"
          :class="{ [`${frameSize}`]: frameSize }"
          autoplay
        ></lite-vimeo>
        <div v-if="data.text" class="videoCard__text">
          <p>Thank you</p>
          <SlpTypography tag="h3" variant="heading4">
            {{ data.text }}
          </SlpTypography>
        </div>
      </div>
    </div>
  </div>
</template>

<style lang="scss" scoped>
.container {
  display: grid;
  grid-template-columns: repeat(4, 1fr);
  padding: 0 15px;
  grid-gap: 15px;
  margin: 0 auto;
  margin-bottom: 64px;
  max-width: 100%;
  @media (min-width: $breakpoint-lg) {
    grid-template-columns: repeat(12, 1fr);
    margin-bottom: 128px;
    max-width: 1140px;
  }
}
.md {
  width: 640px;
  height: 360px;
}

.lg {
  width: 800px;
  height: 450px;
}

.video_header {
  text-align: center;
  margin-top: $spacing-64;
  margin-bottom: $spacing-32;
}

.videoCard {
  align-self: stretch;
  background: #fff;
  color: #333;
  flex: 1;
  grid-column: 1 / -1;
  min-width: 90%;
  position: relative;
  text-align: left;
  transition: all 0.3s ease-in-out;

  @media (min-width: $breakpoint-lg) {
    min-width: 30%;
  }
  &.displace_left {
    @media (min-width: $breakpoint-lg) {
      grid-column: 1 / 11;
    }
  }
}

.videoCard__toggle {
  border: none;
  display: flex;
  flex-direction: column;
  height: 100%;
  padding: 0;
  text-align: left;
  width: 100%;
  z-index: 10;
}

.videoCard__video {
  border: 1px solid #f2f2f2;
  border-radius: 0.375rem 0.375rem 0 0;
}

.videoCard__text {
  align-self: stretch;
  border: none;
  flex: 1;
  padding: 24px 32px;
  position: relative;
}

.videoCard__icon {
  background: #f2f2f2;
  border-radius: 100%;
  display: flex;
  justify-content: center;
  align-items: center;
  left: 0;
  padding: 10px;
  position: absolute;
  top: 0;
  transform: translate(32px, -50%);
}

p {
  color: #333;
  font-size: 10px;
  font-weight: 400;
  letter-spacing: 0.1em;
  line-height: 2;
  text-transform: uppercase;

  @media (min-width: $breakpoint-lg) {
    margin-bottom: 10px;
  }
}

h3 {
  color: #333;
  font-weight: 400;
}
</style>
